// TeXworksScript
// Title:  Package Help
// Description: Shows Distribution Help for Packages
// Author:  Paul Norman
// Version: 0.1
// Date: 2011-02-14
// Script-Type: standalone
// Context: TeXDocument
// Shortcut: Alt+F1, Alt+1

// NEED: You'll have to turn on System commands for this to work

// Install: unzip anywhere in your script folder tree

// USAGE: double click on a package name in Tw editor and use this short cut (above)
//        Or select notinh andf run for a small list of documents - (depending on your distriubtion)

// There is a file beside this script called docsList.txt whcih you can edit if you find other docs you want to include.

// You may need to associate Yap (or other) with .dvi files.

// I originally did it as a Lua script in 2009-09-19
/*
 package = "texdoc " .. TW.target.selection
 os.execute(package)
--  TW.result = package;

*/
// This has a different Short Cut.


const twConst = {
                             SystemAccess_OK : 0,

                         SystemAccess_Failed : 1,

        SystemAccess_PermissionDenied : 2
              }; // end twConst
              
 // eval(TW.app.getGlobal("helper_twPan")); //  Comment if NOT Needed - This includes PhpJs ($P), twConst, msgBox, twPan ($tw), string.toTitleCase() 

function trim(stringToTrim) 
        {
	    return stringToTrim.replace(/^\s+|\s+$/g,"");
          }


 var package = TW.target.selection;
 
 if (package == "")
   {
   
   var catalogue = []; // for internal processing of choice
   var display = []; // for drop down choices
   
    buildList = TW.readFile("docsList.txt").result;
    
    buildList = buildList.split("\n");
    
    for (row = 4; row < buildList.length;  row++) // avoid first four instruction lines
       {
        buildArray = buildList[row].split(",");
        
        catalogue[trim(buildArray[0])] = trim(buildArray[1]);
        display.push(trim(buildArray[0]));
        }
   
    choice = TW.getItem(null, "Tw Get Help Document", "Please Choose/Type Help Document", display, 0, true);
    
    if (choice == undefined)
      {
      package = "exit now";
       }
      else
      {
       package = catalogue[choice];
        } 
   
   
       }
       
     if (package.indexOf("http://") > -1)
      {  
         switch(TW.platform())
         {
          case "Windows":
                command = "start ";
           break;
           
           case "X11":
             command = "xdg-open "; // http://www.pixelbeat.org/cmdline.html
            break;
            
           case "MacOSX":
           case "unknown":
             command = "open "; // http://stackoverflow.com/questions/264395/linux-equivalent-of-the-mac-os-x-open-command
             break;
              } 
       
       }
     else // process as known package's doc
      {
        if (package.indexOf("\\") > -1 || package.indexOf("{") > -1 || package.indexOf("}") > -1) // looks like a latex command 
         {
         
              switch(TW.platform())
         {
          case "Windows":
                command = "start ";
           break;
           
           case "X11":
             command = "xdg-open "; // http://www.pixelbeat.org/cmdline.html
            break;
            
           case "MacOSX":
           case "unknown":
             command = "open "; // http://stackoverflow.com/questions/264395/linux-equivalent-of-the-mac-os-x-open-command
             break;
              }
         
           package = "http://www.google.co.nz/search?q=LaTeX+" + trim(package.replace(/ /g,"+")); 
               
          }
        else // process as known package's doc
         {
         command =   "texdoc " 
         }
        }  
 
 if (TW.platform() == "Windows")
   {
    command = "cmd /c " + command;
     }
     
     
  var   executeThis = command + "\"" + package +"\"";
 
  
   if (package != "exit now")
    {
     response = TW.system(executeThis);
 
   if (response.status != twConst.SystemAccess_OK) // i.e. NOT ok
     {
      TW.information(null, "Tw Message", response.message);
      }
     }
     
// exit now:      
      
 null;
 
 /*
  Dual licensed under the

GPL (http://www.gnu.org/licenses/old-licenses/gpl-2.0.html)
http://www.gnu.org/licenses/old-licenses/gpl-2.0.html

Copyright (c) 2010,2011 Paul A Norman and others in their own right


This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

MIT (http://www.opensource.org/licenses/mit-license.php)

Copyright (c) 2010,2011 Paul A Norman and others in their own right

 Permission is hereby granted, free of charge, to any person obtaining a
 copy of this software and associated documentation files (the
 "Software"), to deal in the Software without restriction, including
 without limitation the rights to use, copy, modify, merge, publish,
 distribute, sublicense, and/or sell copies of the Software, and to
 permit persons to whom the Software is furnished to do so, subject to
 the following conditions:

 The above copyright notice and this permission notice shall be included
 in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 IN NO EVENT SHALL PAUL ANTHONY NORMAN BE LIABLE FOR ANY CLAIM, DAMAGES
 OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
 ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 OTHER DEALINGS IN EITHER THE SOFTWARE OR DOCUMENTATION.

*/